import Qt 4.7

Rectangle {

    property int stateIndex: 1

    width: 300
    height: 200

    Text {
        text: "State: " + parent.state
    }

    RectWithZ {
        id: parentRect
        color: "yellow"
        x: 50; y: 50
        RectWithZ {
            id: childRect
            color: "green"
            x: 35; y: 35
        }
    }

    RectWithZ {
        id: sibling1
        color: "yellow"
        x: 110; y: 50
    }

    RectWithZ {
        id: sibling2
        color: "green"
        x: 145; y: 85
    }

    states: [
        State {
            name: "All z-values zero"
            when: stateIndex == 1
        },
        State {
            name: "Child Below Parent"
            when: stateIndex == 2
            PropertyChanges { target: childRect; z: -0.1 }
        },
        State {
            name: "Child moves with parent"
            when: stateIndex == 3
            PropertyChanges { target: parentRect; z: 0.1 }
        },
        State {
            name: "Second sibling above third"
            when: stateIndex == 4
            PropertyChanges { target: sibling1; z: 0.1 }
        },
        State {
            name: "Second and third siblings up"
            when: stateIndex == 5
            PropertyChanges { target: sibling1; z: 0.1 }
            PropertyChanges { target: sibling2; z: 0.1 }
        }
    ]

    MouseArea {
        anchors.fill: parent
        onClicked:  {
            parent.stateIndex++;
            if (parent.stateIndex == 6) {
                parent.stateIndex = 1;
            }
        }
    }
}
