import Qt 4.7

Rectangle {

    // Updated by the child rectangles whenever a mouse is
    // pressed on one of them.
    property string selectedColor: ""

    id: rootRect
    anchors.margins: 5

    // Each colorRect has additional colorString property
    // since the actual color property is in "#abcdef" format.
    // This rectangle is passed as parameter to each ColorRect
    // so they can update the selectedColor property. Not
    // really a good solution since there's a backward dependency.
    // A better one could use signal with colorString as parameter
    // to notify the change.
    Column {
        spacing: 5
        ColorRect { colorString: "red"; rootRect: rootRect }
        ColorRect { colorString: "green"; rootRect: rootRect }
        ColorRect { colorString: "blue"; rootRect: rootRect }
        ColorRect { colorString: "yellow"; rootRect: rootRect }
        ColorRect { colorString: "cyan"; rootRect: rootRect }
        ColorRect { colorString: "magenta"; rootRect: rootRect }
    }
}
