import Qt 4.7

Rectangle {
    width: 400
    height: 400

    // Source image is 87x100 pixels

    // Default behavior is stretch to fit both dimensions
    Image {
        width: 200; height: 200
        source: "http://doc.qt.nokia.com/4.7/images/declarative-qtlogo.png"
    }

    // Tile will insert images repeatedly
    // TileHorizontally and TileVertically also available
    Image {
        y: 200; width: 200; height: 200
        fillMode: Image.Tile
        source: "http://doc.qt.nokia.com/4.7/images/declarative-qtlogo.png"
    }

    // PreserveAspectFit scales the larger of the original dimensions to fit
    // The smaller dimension will have empty areas on both sides
    Image {
        x: 200; width: 200; height: 200
        fillMode: Image.PreserveAspectFit
        source: "http://doc.qt.nokia.com/4.7/images/declarative-qtlogo.png"
    }

    // PreserveAspectCrop scales the smaller of the original dimensions to fit
    // Any excess from the larger dimension gets cropped
    Image {
        x: 200; y: 200; width: 200; height: 200
        fillMode: Image.PreserveAspectCrop
        source: "http://doc.qt.nokia.com/4.7/images/declarative-qtlogo.png"
    }
}
