function runAll()
{
//    jsBasics();
//    jsFunctions();
//    jsClosures();
//    jsObjects();
//    jsObjectInheritance();
//    jsObjectFunctions();
}

function jsBasics()
{
    // If-else
    var i = 10;
    if (i < 10) {
        console.log("Less");
    } else if (i < 10) {
        console.log("More");
    } else {
        console.log("Match");
    }

    // For loop
    var obj = [4,3,2,1,0];
    for (i = 0; i < 5; i++) {
        console.log("for: " + obj[i]);
    }

    // While loop
    i = 0;
    while (i < 5) {
        console.log("while: " + obj[i]);
        i++;
    }

    // Loop over all elements of array or object
    for (i in obj) {
        console.log("for-in: " + obj[i]);
    }
}

function jsFunctions()
{
    // Create a function, which takes a function as parameter
    var func = function(funcIn) { console.log("Func: "  + funcIn("World")); }

    // Another function, which returns a string
    var hello = function(param) { return "Hello " + param; }

    // Calls func, passes hello into it
    func(hello);
}

function jsClosures()
{
    function createMultiplierFunc(multiplier) {
        return function(x) { return x * multiplier; }
    }

    // Creates two functions, one multiplies it's parameter by 5 and another by 8
    var mul5 = createMultiplierFunc(5);
    var mul8 = createMultiplierFunc(8);

    // Call the functions with 10 as parameter
    console.log("10*5 = " + mul5(10));
    console.log("10*8 = " + mul8(10));
}

function jsObjects()
{
    // Define a 'constructor' function
    function MyObj(x) {
        this.xVal = x;
    }

    // Assign a function to the 'constructor' prototype
    // All objects created with new will inherit the
    // constructor prototype functions
    MyObj.prototype.print = function() { console.log("X: " + this.xVal); }

    // Create new object and call its print function
    var obj = new MyObj(57);
    obj.print();
}

function jsObjectInheritance()
{
    var obj = {
        id: 57,
        data: {
            name: "Name",
            description: "Hello World!!!",
            value: 127
        }
    }

    // Values can be accessed in two ways
    console.log("ID: " + obj.id + " " + obj["id"]);

    // Undefined value
    console.log("ID 2: " + obj.id2)

    // Object properties can also be accessed with for-in
    for (var i in obj.data) {
        console.log(obj.data[i]);
    }

    // Create another object
    var obj2 = { id2: 58 }

    // Inherit from obj by prototype assignment
    obj2.__proto__ = obj

    // Log obj2 properties
    console.log("ID: " + obj2.id);
    console.log("ID 2: " + obj2.id2)
    console.log(obj2.data.description);
}

function jsObjectFunctions()
{
    var obj = { stuff: 123 }

    // Add a function to object
    obj.printStuff = function() { console.log("Stuff: " + this.stuff); }

    // Create new object which inherits the previous one
    var obj2 = {}
    obj2.__proto__ = obj

    // Overwrite the base class function
    obj2.printStuff = function() { console.log("Stuff 2: " + this.stuff * 2); }

    // Call the functions
    obj.printStuff();
    obj2.printStuff();
}
